#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstring>

#define TASKNAME "scout"
typedef double real;

const int MaxN = 62, MaxK = (60 * 59 * 60 * 59) / 8;
const real eps = 1E-9;

int x [MaxN], y [MaxN];
real xans [MaxK], yans [MaxK];
int m, n;

inline int sp (int x0, int y0, int x1, int y1, int x2, int y2)
{
 return (x1 - x0) * (x2 - x0) + (y1 - y0) * (y2 - y0);
}

inline int vp (int x0, int y0, int x1, int y1, int x2, int y2)
{
 return (x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0);
}

int main (void)
{
 int i, j, k, l;
 int a1, a2, b1, b2, c1, c2, p, q;
 real xc, yc, r;
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  for (i = 0; i < n; i++)
   scanf (" %d %d", &x[i], &y[i]);
  m = 0;
  for (i = n - 1; i >= 0; i--)
   for (j = i - 1; j >= 0; j--)
    for (k = i - 1; k >= 0; k--) if (k != j)
     for (l = k - 1; l >= 0; l--) if (l != j)
     {
      p = vp (x[i], y[i], x[j], y[j], x[k], y[k]);
      q = vp (x[i], y[i], x[j], y[j], x[l], y[l]);
      if ((p > 0) == (q > 0)) continue;
      p = vp (x[k], y[k], x[l], y[l], x[i], y[i]);
      q = vp (x[k], y[k], x[l], y[l], x[j], y[j]);
      if ((p > 0) == (q > 0)) continue;
      a1 = y[i] - y[j];
      b1 = x[j] - x[i];
      c1 = a1 * x[i] + b1 * y[i];
      a2 = y[k] - y[l];
      b2 = x[l] - x[k];
      c2 = a2 * x[k] + b2 * y[k];
      r = a1 * b2 - a2 * b1;
      xc = (a1 * c2 - a2 * c1) / r;
      yc = (b2 * c1 - b1 * c2) / r;
      for (p = 0; p < m; p++)
       if (fabs (xc - xans[p]) < eps && fabs (yc - yans[p]) < eps)
        break;
      if (p == m)
      {
       xans[p] = xc;
       yans[p] = yc;
       m++;
      }
     }
  printf ("%d\n", m);
 }
 return 0;
}
